/* bfd_peer_detectmultiplier => "detect-multiplier (2-255)$multiplier" */
DEFUN_CMD_FUNC_DECL(bfd_peer_detectmultiplier)
#define funcdecl_bfd_peer_detectmultiplier static int bfd_peer_detectmultiplier_magic(\
	const struct cmd_element *self __attribute__ ((unused)),\
	struct vty *vty __attribute__ ((unused)),\
	int argc __attribute__ ((unused)),\
	struct cmd_token *argv[] __attribute__ ((unused)),\
	long multiplier,\
	const char * multiplier_str __attribute__ ((unused)))
funcdecl_bfd_peer_detectmultiplier;
DEFUN_CMD_FUNC_TEXT(bfd_peer_detectmultiplier)
{
#if 1 /* anything to parse? */
	int _i;
#if 1 /* anything that can fail? */
	unsigned _fail = 0, _failcnt = 0;
#endif
	long multiplier = 0;
	const char *multiplier_str = NULL;

	for (_i = 0; _i < argc; _i++) {
		if (!argv[_i]->varname)
			continue;
#if 1 /* anything that can fail? */
		_fail = 0;
#endif

		if (!strcmp(argv[_i]->varname, "multiplier")) {
			multiplier_str = argv[_i]->arg;
			char *_end;
			multiplier = strtol(argv[_i]->arg, &_end, 10);
			_fail = (_end == argv[_i]->arg) || (*_end != '\0');
		}
#if 1 /* anything that can fail? */
		if (_fail)
			vty_out (vty, "%% invalid input for %s: %s\n",
				   argv[_i]->varname, argv[_i]->arg);
		_failcnt += _fail;
#endif
	}
#if 1 /* anything that can fail? */
	if (_failcnt)
		return CMD_WARNING;
#endif
#endif
	return bfd_peer_detectmultiplier_magic(self, vty, argc, argv, multiplier, multiplier_str);
}

/* bfd_peer_recvinterval => "receive-interval (10-60000)$interval" */
DEFUN_CMD_FUNC_DECL(bfd_peer_recvinterval)
#define funcdecl_bfd_peer_recvinterval static int bfd_peer_recvinterval_magic(\
	const struct cmd_element *self __attribute__ ((unused)),\
	struct vty *vty __attribute__ ((unused)),\
	int argc __attribute__ ((unused)),\
	struct cmd_token *argv[] __attribute__ ((unused)),\
	long interval,\
	const char * interval_str __attribute__ ((unused)))
funcdecl_bfd_peer_recvinterval;
DEFUN_CMD_FUNC_TEXT(bfd_peer_recvinterval)
{
#if 1 /* anything to parse? */
	int _i;
#if 1 /* anything that can fail? */
	unsigned _fail = 0, _failcnt = 0;
#endif
	long interval = 0;
	const char *interval_str = NULL;

	for (_i = 0; _i < argc; _i++) {
		if (!argv[_i]->varname)
			continue;
#if 1 /* anything that can fail? */
		_fail = 0;
#endif

		if (!strcmp(argv[_i]->varname, "interval")) {
			interval_str = argv[_i]->arg;
			char *_end;
			interval = strtol(argv[_i]->arg, &_end, 10);
			_fail = (_end == argv[_i]->arg) || (*_end != '\0');
		}
#if 1 /* anything that can fail? */
		if (_fail)
			vty_out (vty, "%% invalid input for %s: %s\n",
				   argv[_i]->varname, argv[_i]->arg);
		_failcnt += _fail;
#endif
	}
#if 1 /* anything that can fail? */
	if (_failcnt)
		return CMD_WARNING;
#endif
#endif
	return bfd_peer_recvinterval_magic(self, vty, argc, argv, interval, interval_str);
}

/* bfd_peer_txinterval => "transmit-interval (10-60000)$interval" */
DEFUN_CMD_FUNC_DECL(bfd_peer_txinterval)
#define funcdecl_bfd_peer_txinterval static int bfd_peer_txinterval_magic(\
	const struct cmd_element *self __attribute__ ((unused)),\
	struct vty *vty __attribute__ ((unused)),\
	int argc __attribute__ ((unused)),\
	struct cmd_token *argv[] __attribute__ ((unused)),\
	long interval,\
	const char * interval_str __attribute__ ((unused)))
funcdecl_bfd_peer_txinterval;
DEFUN_CMD_FUNC_TEXT(bfd_peer_txinterval)
{
#if 1 /* anything to parse? */
	int _i;
#if 1 /* anything that can fail? */
	unsigned _fail = 0, _failcnt = 0;
#endif
	long interval = 0;
	const char *interval_str = NULL;

	for (_i = 0; _i < argc; _i++) {
		if (!argv[_i]->varname)
			continue;
#if 1 /* anything that can fail? */
		_fail = 0;
#endif

		if (!strcmp(argv[_i]->varname, "interval")) {
			interval_str = argv[_i]->arg;
			char *_end;
			interval = strtol(argv[_i]->arg, &_end, 10);
			_fail = (_end == argv[_i]->arg) || (*_end != '\0');
		}
#if 1 /* anything that can fail? */
		if (_fail)
			vty_out (vty, "%% invalid input for %s: %s\n",
				   argv[_i]->varname, argv[_i]->arg);
		_failcnt += _fail;
#endif
	}
#if 1 /* anything that can fail? */
	if (_failcnt)
		return CMD_WARNING;
#endif
#endif
	return bfd_peer_txinterval_magic(self, vty, argc, argv, interval, interval_str);
}

/* bfd_peer_echointerval => "echo-interval (10-60000)$interval" */
DEFUN_CMD_FUNC_DECL(bfd_peer_echointerval)
#define funcdecl_bfd_peer_echointerval static int bfd_peer_echointerval_magic(\
	const struct cmd_element *self __attribute__ ((unused)),\
	struct vty *vty __attribute__ ((unused)),\
	int argc __attribute__ ((unused)),\
	struct cmd_token *argv[] __attribute__ ((unused)),\
	long interval,\
	const char * interval_str __attribute__ ((unused)))
funcdecl_bfd_peer_echointerval;
DEFUN_CMD_FUNC_TEXT(bfd_peer_echointerval)
{
#if 1 /* anything to parse? */
	int _i;
#if 1 /* anything that can fail? */
	unsigned _fail = 0, _failcnt = 0;
#endif
	long interval = 0;
	const char *interval_str = NULL;

	for (_i = 0; _i < argc; _i++) {
		if (!argv[_i]->varname)
			continue;
#if 1 /* anything that can fail? */
		_fail = 0;
#endif

		if (!strcmp(argv[_i]->varname, "interval")) {
			interval_str = argv[_i]->arg;
			char *_end;
			interval = strtol(argv[_i]->arg, &_end, 10);
			_fail = (_end == argv[_i]->arg) || (*_end != '\0');
		}
#if 1 /* anything that can fail? */
		if (_fail)
			vty_out (vty, "%% invalid input for %s: %s\n",
				   argv[_i]->varname, argv[_i]->arg);
		_failcnt += _fail;
#endif
	}
#if 1 /* anything that can fail? */
	if (_failcnt)
		return CMD_WARNING;
#endif
#endif
	return bfd_peer_echointerval_magic(self, vty, argc, argv, interval, interval_str);
}

/* bfd_peer_shutdown => "[no] shutdown" */
DEFUN_CMD_FUNC_DECL(bfd_peer_shutdown)
#define funcdecl_bfd_peer_shutdown static int bfd_peer_shutdown_magic(\
	const struct cmd_element *self __attribute__ ((unused)),\
	struct vty *vty __attribute__ ((unused)),\
	int argc __attribute__ ((unused)),\
	struct cmd_token *argv[] __attribute__ ((unused)),\
	const char * no)
funcdecl_bfd_peer_shutdown;
DEFUN_CMD_FUNC_TEXT(bfd_peer_shutdown)
{
#if 1 /* anything to parse? */
	int _i;
#if 0 /* anything that can fail? */
	unsigned _fail = 0, _failcnt = 0;
#endif
	const char *no = NULL;

	for (_i = 0; _i < argc; _i++) {
		if (!argv[_i]->varname)
			continue;
#if 0 /* anything that can fail? */
		_fail = 0;
#endif

		if (!strcmp(argv[_i]->varname, "no")) {
			no = argv[_i]->arg;
		}
#if 0 /* anything that can fail? */
		if (_fail)
			vty_out (vty, "%% invalid input for %s: %s\n",
				   argv[_i]->varname, argv[_i]->arg);
		_failcnt += _fail;
#endif
	}
#if 0 /* anything that can fail? */
	if (_failcnt)
		return CMD_WARNING;
#endif
#endif
	return bfd_peer_shutdown_magic(self, vty, argc, argv, no);
}

/* bfd_peer_echo => "[no] echo-mode" */
DEFUN_CMD_FUNC_DECL(bfd_peer_echo)
#define funcdecl_bfd_peer_echo static int bfd_peer_echo_magic(\
	const struct cmd_element *self __attribute__ ((unused)),\
	struct vty *vty __attribute__ ((unused)),\
	int argc __attribute__ ((unused)),\
	struct cmd_token *argv[] __attribute__ ((unused)),\
	const char * no)
funcdecl_bfd_peer_echo;
DEFUN_CMD_FUNC_TEXT(bfd_peer_echo)
{
#if 1 /* anything to parse? */
	int _i;
#if 0 /* anything that can fail? */
	unsigned _fail = 0, _failcnt = 0;
#endif
	const char *no = NULL;

	for (_i = 0; _i < argc; _i++) {
		if (!argv[_i]->varname)
			continue;
#if 0 /* anything that can fail? */
		_fail = 0;
#endif

		if (!strcmp(argv[_i]->varname, "no")) {
			no = argv[_i]->arg;
		}
#if 0 /* anything that can fail? */
		if (_fail)
			vty_out (vty, "%% invalid input for %s: %s\n",
				   argv[_i]->varname, argv[_i]->arg);
		_failcnt += _fail;
#endif
	}
#if 0 /* anything that can fail? */
	if (_failcnt)
		return CMD_WARNING;
#endif
#endif
	return bfd_peer_echo_magic(self, vty, argc, argv, no);
}

/* bfd_peer_label => "label WORD$label" */
DEFUN_CMD_FUNC_DECL(bfd_peer_label)
#define funcdecl_bfd_peer_label static int bfd_peer_label_magic(\
	const struct cmd_element *self __attribute__ ((unused)),\
	struct vty *vty __attribute__ ((unused)),\
	int argc __attribute__ ((unused)),\
	struct cmd_token *argv[] __attribute__ ((unused)),\
	const char * label)
funcdecl_bfd_peer_label;
DEFUN_CMD_FUNC_TEXT(bfd_peer_label)
{
#if 1 /* anything to parse? */
	int _i;
#if 0 /* anything that can fail? */
	unsigned _fail = 0, _failcnt = 0;
#endif
	const char *label = NULL;

	for (_i = 0; _i < argc; _i++) {
		if (!argv[_i]->varname)
			continue;
#if 0 /* anything that can fail? */
		_fail = 0;
#endif

		if (!strcmp(argv[_i]->varname, "label")) {
			label = argv[_i]->arg;
		}
#if 0 /* anything that can fail? */
		if (_fail)
			vty_out (vty, "%% invalid input for %s: %s\n",
				   argv[_i]->varname, argv[_i]->arg);
		_failcnt += _fail;
#endif
	}
#if 0 /* anything that can fail? */
	if (_failcnt)
		return CMD_WARNING;
#endif
#endif
	return bfd_peer_label_magic(self, vty, argc, argv, label);
}

/* bfd_no_peer => "no peer <A.B.C.D|X:X::X:X>$peer [{multihop|local-address <A.B.C.D|X:X::X:X>$local|interface IFNAME$ifname|vrf NAME$vrfname}]" */
DEFUN_CMD_FUNC_DECL(bfd_no_peer)
#define funcdecl_bfd_no_peer static int bfd_no_peer_magic(\
	const struct cmd_element *self __attribute__ ((unused)),\
	struct vty *vty __attribute__ ((unused)),\
	int argc __attribute__ ((unused)),\
	struct cmd_token *argv[] __attribute__ ((unused)),\
	const union sockunion * peer,\
	const char * peer_str __attribute__ ((unused)),\
	const union sockunion * local,\
	const char * local_str __attribute__ ((unused)),\
	const char * ifname,\
	const char * vrfname)
funcdecl_bfd_no_peer;
DEFUN_CMD_FUNC_TEXT(bfd_no_peer)
{
#if 4 /* anything to parse? */
	int _i;
#if 1 /* anything that can fail? */
	unsigned _fail = 0, _failcnt = 0;
#endif
	union sockunion s__peer = { .sa.sa_family = AF_UNSPEC }, *peer = NULL;
	const char *peer_str = NULL;
	union sockunion s__local = { .sa.sa_family = AF_UNSPEC }, *local = NULL;
	const char *local_str = NULL;
	const char *ifname = NULL;
	const char *vrfname = NULL;

	for (_i = 0; _i < argc; _i++) {
		if (!argv[_i]->varname)
			continue;
#if 1 /* anything that can fail? */
		_fail = 0;
#endif

		if (!strcmp(argv[_i]->varname, "peer")) {
			peer_str = argv[_i]->arg;
			if (argv[_i]->text[0] == 'X') {
				s__peer.sa.sa_family = AF_INET6;
				_fail = !inet_pton(AF_INET6, argv[_i]->arg, &s__peer.sin6.sin6_addr);
				peer = &s__peer;
			} else {
				s__peer.sa.sa_family = AF_INET;
				_fail = !inet_aton(argv[_i]->arg, &s__peer.sin.sin_addr);
				peer = &s__peer;
			}
		}
		if (!strcmp(argv[_i]->varname, "local")) {
			local_str = argv[_i]->arg;
			if (argv[_i]->text[0] == 'X') {
				s__local.sa.sa_family = AF_INET6;
				_fail = !inet_pton(AF_INET6, argv[_i]->arg, &s__local.sin6.sin6_addr);
				local = &s__local;
			} else {
				s__local.sa.sa_family = AF_INET;
				_fail = !inet_aton(argv[_i]->arg, &s__local.sin.sin_addr);
				local = &s__local;
			}
		}
		if (!strcmp(argv[_i]->varname, "ifname")) {
			ifname = argv[_i]->arg;
		}
		if (!strcmp(argv[_i]->varname, "vrfname")) {
			vrfname = argv[_i]->arg;
		}
#if 1 /* anything that can fail? */
		if (_fail)
			vty_out (vty, "%% invalid input for %s: %s\n",
				   argv[_i]->varname, argv[_i]->arg);
		_failcnt += _fail;
#endif
	}
#if 1 /* anything that can fail? */
	if (_failcnt)
		return CMD_WARNING;
#endif
#endif
	return bfd_no_peer_magic(self, vty, argc, argv, peer, peer_str, local, local_str, ifname, vrfname);
}

/* bfd_show_peers => "show bfd peers [json]" */
DEFUN_CMD_FUNC_DECL(bfd_show_peers)
#define funcdecl_bfd_show_peers static int bfd_show_peers_magic(\
	const struct cmd_element *self __attribute__ ((unused)),\
	struct vty *vty __attribute__ ((unused)),\
	int argc __attribute__ ((unused)),\
	struct cmd_token *argv[] __attribute__ ((unused)))
funcdecl_bfd_show_peers;
DEFUN_CMD_FUNC_TEXT(bfd_show_peers)
{
#if 0 /* anything to parse? */
	int _i;
#if 0 /* anything that can fail? */
	unsigned _fail = 0, _failcnt = 0;
#endif

	for (_i = 0; _i < argc; _i++) {
		if (!argv[_i]->varname)
			continue;
#if 0 /* anything that can fail? */
		_fail = 0;
#endif

#if 0 /* anything that can fail? */
		if (_fail)
			vty_out (vty, "%% invalid input for %s: %s\n",
				   argv[_i]->varname, argv[_i]->arg);
		_failcnt += _fail;
#endif
	}
#if 0 /* anything that can fail? */
	if (_failcnt)
		return CMD_WARNING;
#endif
#endif
	return bfd_show_peers_magic(self, vty, argc, argv);
}

/* bfd_show_peer => "show bfd peer <WORD$label|<A.B.C.D|X:X::X:X>$peer [{multihop|local-address <A.B.C.D|X:X::X:X>$local|interface IFNAME$ifname|vrf NAME$vrfname}]> [json]" */
DEFUN_CMD_FUNC_DECL(bfd_show_peer)
#define funcdecl_bfd_show_peer static int bfd_show_peer_magic(\
	const struct cmd_element *self __attribute__ ((unused)),\
	struct vty *vty __attribute__ ((unused)),\
	int argc __attribute__ ((unused)),\
	struct cmd_token *argv[] __attribute__ ((unused)),\
	const char * label,\
	const union sockunion * peer,\
	const char * peer_str __attribute__ ((unused)),\
	const union sockunion * local,\
	const char * local_str __attribute__ ((unused)),\
	const char * ifname,\
	const char * vrfname)
funcdecl_bfd_show_peer;
DEFUN_CMD_FUNC_TEXT(bfd_show_peer)
{
#if 5 /* anything to parse? */
	int _i;
#if 1 /* anything that can fail? */
	unsigned _fail = 0, _failcnt = 0;
#endif
	const char *label = NULL;
	union sockunion s__peer = { .sa.sa_family = AF_UNSPEC }, *peer = NULL;
	const char *peer_str = NULL;
	union sockunion s__local = { .sa.sa_family = AF_UNSPEC }, *local = NULL;
	const char *local_str = NULL;
	const char *ifname = NULL;
	const char *vrfname = NULL;

	for (_i = 0; _i < argc; _i++) {
		if (!argv[_i]->varname)
			continue;
#if 1 /* anything that can fail? */
		_fail = 0;
#endif

		if (!strcmp(argv[_i]->varname, "label")) {
			label = argv[_i]->arg;
		}
		if (!strcmp(argv[_i]->varname, "peer")) {
			peer_str = argv[_i]->arg;
			if (argv[_i]->text[0] == 'X') {
				s__peer.sa.sa_family = AF_INET6;
				_fail = !inet_pton(AF_INET6, argv[_i]->arg, &s__peer.sin6.sin6_addr);
				peer = &s__peer;
			} else {
				s__peer.sa.sa_family = AF_INET;
				_fail = !inet_aton(argv[_i]->arg, &s__peer.sin.sin_addr);
				peer = &s__peer;
			}
		}
		if (!strcmp(argv[_i]->varname, "local")) {
			local_str = argv[_i]->arg;
			if (argv[_i]->text[0] == 'X') {
				s__local.sa.sa_family = AF_INET6;
				_fail = !inet_pton(AF_INET6, argv[_i]->arg, &s__local.sin6.sin6_addr);
				local = &s__local;
			} else {
				s__local.sa.sa_family = AF_INET;
				_fail = !inet_aton(argv[_i]->arg, &s__local.sin.sin_addr);
				local = &s__local;
			}
		}
		if (!strcmp(argv[_i]->varname, "ifname")) {
			ifname = argv[_i]->arg;
		}
		if (!strcmp(argv[_i]->varname, "vrfname")) {
			vrfname = argv[_i]->arg;
		}
#if 1 /* anything that can fail? */
		if (_fail)
			vty_out (vty, "%% invalid input for %s: %s\n",
				   argv[_i]->varname, argv[_i]->arg);
		_failcnt += _fail;
#endif
	}
#if 1 /* anything that can fail? */
	if (_failcnt)
		return CMD_WARNING;
#endif
#endif
	return bfd_show_peer_magic(self, vty, argc, argv, label, peer, peer_str, local, local_str, ifname, vrfname);
}

/* bfd_show_peer_counters => "show bfd peer <WORD$label|<A.B.C.D|X:X::X:X>$peer [{multihop|local-address <A.B.C.D|X:X::X:X>$local|interface IFNAME$ifname|vrf NAME$vrfname}]> counters [json]" */
DEFUN_CMD_FUNC_DECL(bfd_show_peer_counters)
#define funcdecl_bfd_show_peer_counters static int bfd_show_peer_counters_magic(\
	const struct cmd_element *self __attribute__ ((unused)),\
	struct vty *vty __attribute__ ((unused)),\
	int argc __attribute__ ((unused)),\
	struct cmd_token *argv[] __attribute__ ((unused)),\
	const char * label,\
	const union sockunion * peer,\
	const char * peer_str __attribute__ ((unused)),\
	const union sockunion * local,\
	const char * local_str __attribute__ ((unused)),\
	const char * ifname,\
	const char * vrfname)
funcdecl_bfd_show_peer_counters;
DEFUN_CMD_FUNC_TEXT(bfd_show_peer_counters)
{
#if 5 /* anything to parse? */
	int _i;
#if 1 /* anything that can fail? */
	unsigned _fail = 0, _failcnt = 0;
#endif
	const char *label = NULL;
	union sockunion s__peer = { .sa.sa_family = AF_UNSPEC }, *peer = NULL;
	const char *peer_str = NULL;
	union sockunion s__local = { .sa.sa_family = AF_UNSPEC }, *local = NULL;
	const char *local_str = NULL;
	const char *ifname = NULL;
	const char *vrfname = NULL;

	for (_i = 0; _i < argc; _i++) {
		if (!argv[_i]->varname)
			continue;
#if 1 /* anything that can fail? */
		_fail = 0;
#endif

		if (!strcmp(argv[_i]->varname, "label")) {
			label = argv[_i]->arg;
		}
		if (!strcmp(argv[_i]->varname, "peer")) {
			peer_str = argv[_i]->arg;
			if (argv[_i]->text[0] == 'X') {
				s__peer.sa.sa_family = AF_INET6;
				_fail = !inet_pton(AF_INET6, argv[_i]->arg, &s__peer.sin6.sin6_addr);
				peer = &s__peer;
			} else {
				s__peer.sa.sa_family = AF_INET;
				_fail = !inet_aton(argv[_i]->arg, &s__peer.sin.sin_addr);
				peer = &s__peer;
			}
		}
		if (!strcmp(argv[_i]->varname, "local")) {
			local_str = argv[_i]->arg;
			if (argv[_i]->text[0] == 'X') {
				s__local.sa.sa_family = AF_INET6;
				_fail = !inet_pton(AF_INET6, argv[_i]->arg, &s__local.sin6.sin6_addr);
				local = &s__local;
			} else {
				s__local.sa.sa_family = AF_INET;
				_fail = !inet_aton(argv[_i]->arg, &s__local.sin.sin_addr);
				local = &s__local;
			}
		}
		if (!strcmp(argv[_i]->varname, "ifname")) {
			ifname = argv[_i]->arg;
		}
		if (!strcmp(argv[_i]->varname, "vrfname")) {
			vrfname = argv[_i]->arg;
		}
#if 1 /* anything that can fail? */
		if (_fail)
			vty_out (vty, "%% invalid input for %s: %s\n",
				   argv[_i]->varname, argv[_i]->arg);
		_failcnt += _fail;
#endif
	}
#if 1 /* anything that can fail? */
	if (_failcnt)
		return CMD_WARNING;
#endif
#endif
	return bfd_show_peer_counters_magic(self, vty, argc, argv, label, peer, peer_str, local, local_str, ifname, vrfname);
}

/* bfd_show_peers_counters => "show bfd peers counters [json]" */
DEFUN_CMD_FUNC_DECL(bfd_show_peers_counters)
#define funcdecl_bfd_show_peers_counters static int bfd_show_peers_counters_magic(\
	const struct cmd_element *self __attribute__ ((unused)),\
	struct vty *vty __attribute__ ((unused)),\
	int argc __attribute__ ((unused)),\
	struct cmd_token *argv[] __attribute__ ((unused)))
funcdecl_bfd_show_peers_counters;
DEFUN_CMD_FUNC_TEXT(bfd_show_peers_counters)
{
#if 0 /* anything to parse? */
	int _i;
#if 0 /* anything that can fail? */
	unsigned _fail = 0, _failcnt = 0;
#endif

	for (_i = 0; _i < argc; _i++) {
		if (!argv[_i]->varname)
			continue;
#if 0 /* anything that can fail? */
		_fail = 0;
#endif

#if 0 /* anything that can fail? */
		if (_fail)
			vty_out (vty, "%% invalid input for %s: %s\n",
				   argv[_i]->varname, argv[_i]->arg);
		_failcnt += _fail;
#endif
	}
#if 0 /* anything that can fail? */
	if (_failcnt)
		return CMD_WARNING;
#endif
#endif
	return bfd_show_peers_counters_magic(self, vty, argc, argv);
}

